from ngsolve import *
from netgen.geom2d import unit_square

# generate a triangular mesh of mesh-size 0.2
meshCoarse = Mesh(unit_square.GenerateMesh(maxh=0.2))

print(meshCoarse.GetBoundaries())

# H1-conforming finite element space
fesCoarse = H1(meshCoarse, order=1)

gfudCoarse = GridFunction(fesCoarse)
gfudCoarse.Set(x*y**2)

ngmeshCoarseCopy = meshCoarse.ngmesh.Copy()
ngmeshCoarseCopy.Refine()
ngmeshCoarseCopy.Refine()
mesh = Mesh(ngmeshCoarseCopy)

fes = H1(mesh,order = 1)
gfud = GridFunction(fes)

print(Norm(gfudCoarse.vec))
gfud.Set(gfudCoarse)
print(Norm(gfud.vec))

Draw(gfud, mesh, "gfud")
input("pause")
